diff -uNrd ircd-hybrid-6.0/src/s_conf.c ircd-pi1.0a/src/s_conf.c
--- ircd-hybrid-6.0/src/s_conf.c	Fri Dec  1 01:28:50 2000
+++ ircd-pi1.0a/src/s_conf.c	Thu May 23 00:22:22 2002
@@ -19,7 +19,7 @@
  *
  *  (C) 1988 University of Oulu,Computing Center and Jarkko Oikarinen"
  *
- *  $Id: s_conf.c,v 1.192 2000/12/01 06:28:50 lusky Exp $
+ *  $Id: s_conf.c,v 1.14 2002/05/23 04:22:22 smoli Exp $
  */
 #include "s_conf.h"
 #include "channel.h"
@@ -40,6 +40,10 @@
 #include "send.h"
 #include "struct.h"
 #include "s_debug.h"
+#ifdef HAVE_SSL
+#include "ssl.h"
+#endif
+#include "config.h"
 
 #include <stdio.h>
 #include <string.h>
@@ -70,7 +74,7 @@
 static char *getfield(char *newline);
 
 static FBFILE*  openconf(const char* filename);
-static void     initconf(FBFILE*, int);
+static int      initconf(FBFILE*, int);
 static void     clear_out_old_conf(void);
 static void     flush_deleted_I_P(void);
 
@@ -146,6 +150,11 @@
 /* keep track of .include files to hash in */
 struct ConfItem        *include_list = ((struct ConfItem *)NULL);
 
+#ifdef BACKUP
+struct ConfItem *main_link = ((struct ConfItem *)NULL);
+struct ConfItem *backup_link = ((struct ConfItem *)NULL);
+#endif /* BACKUP */
+
 /*
  * conf_dns_callback - called when resolver query finishes
  * if the query resulted in a successful search, hp will contain
@@ -224,7 +233,7 @@
     delete_resolver_queries(aconf);
   MyFree(aconf->host);
   if (aconf->passwd)
-    memset(aconf->passwd, 0, strlen(aconf->passwd));
+    memset(aconf->passwd, 0, irclen(aconf->passwd));
   MyFree(aconf->passwd);
   MyFree(aconf->user);
   MyFree(aconf->name);
@@ -884,7 +893,7 @@
   else
     {
       (void)sprintf(result_buf,"*** hash stats for iphash\n");
-      (void)write(out,result_buf,strlen(result_buf));
+      (void)write(out,result_buf,irclen(result_buf));
     }
 
   for(i = 0; i < IP_HASH_SIZE ;i++)
@@ -908,7 +917,7 @@
             {
               (void)sprintf(result_buf,"Entry %d (0x%X) Collisions %d\n",
                             i,i,collision_count);
-              (void)write(out,result_buf,strlen(result_buf));
+              (void)write(out,result_buf,irclen(result_buf));
             }
         }
     }
@@ -1042,9 +1051,12 @@
             }
           else
             {
-              send(cptr->fd,
-                   "NOTICE FLINE :I: line is full, but you have an >I: line!\n",
-                   56, 0);
+#ifdef HAVE_SSL
+              if(!IsSSL(cptr))
+#endif              
+                send(cptr->fd,
+                     "NOTICE FLINE :I: line is full, but you have an F: line!\n",
+                     55, 0);
               SetFlined(cptr);
             }
 
@@ -1134,36 +1146,67 @@
  */
 int attach_cn_lines(aClient *cptr, const char* host)
 {
-  struct ConfItem* tmp;
+  struct ConfItem *tmp;
+  char            *name = NULL;
   int              found_cline = 0;
-  int              found_nline = 0; 
+  int              found_nline = 0;
+  
   assert(0 != cptr);
   assert(0 != host);
 
-  for (tmp = ConfigItemList; tmp; tmp = tmp->next) {
-    if (!IsIllegal(tmp)) {
-      /*
-       * look for matching C:line
-       */
-      if (!found_cline && CONF_CONNECT_SERVER == tmp->status && 
-          tmp->host && 0 == irccmp(tmp->host, host)) {
-        attach_conf(cptr, tmp);
-        if (found_nline)
-          return 1;
-        found_cline = 1;
-      }
-      /*
-       * look for matching N:line
-       */
-      else if (!found_nline && CONF_NOCONNECT_SERVER == tmp->status &&
-               tmp->host && 0 == irccmp(tmp->host, host)) {
-        attach_conf(cptr, tmp);
-        if (found_cline)
-          return 1;
-        found_nline = 1;
-      }
+  /* search the config entry by name first, then if it fails by host.
+   * with this we achieve that C/N lines match by name, not host
+   * (hosts may be different, e.g. a mask in N-line) */
+  for(tmp = ConfigItemList; tmp && cptr->name; tmp = tmp->next)
+    if(!IsIllegal(tmp) && CONF_CONNECT_SERVER == tmp->status &&
+       irccmp(tmp->name, cptr->name) == 0)
+      name = tmp->name;
+  
+  for(tmp = ConfigItemList; tmp && !name; tmp = tmp->next)
+    if(!IsIllegal(tmp) && CONF_CONNECT_SERVER == tmp->status &&
+       irccmp(tmp->host, host))
+      name = tmp->name;
+  
+  if(name == NULL)
+    return 0;
+  
+  for(tmp = ConfigItemList; tmp; tmp = tmp->next)
+    {
+      if(!IsIllegal(tmp))
+        {
+          /*
+           * look for matching C:line
+           */
+          if(!found_cline && CONF_CONNECT_SERVER == tmp->status && 
+             tmp->host && 0 == irccmp(tmp->name, name))
+            {
+              attach_conf(cptr, tmp);
+        
+              if(found_nline)
+              return 1;
+        
+              found_cline = 1;
+            }
+        
+          /*
+           * look for matching N:line
+           */
+          else if(!found_nline && CONF_NOCONNECT_SERVER == tmp->status &&
+                tmp->host && 0 == irccmp(tmp->name, name))
+            {
+#ifdef HAVE_SSL
+              if(tmp->connect_ssl)
+                SetSSL(cptr);
+#endif
+              attach_conf(cptr, tmp);
+        
+              if(found_cline)
+                return 1;
+        
+              found_nline = 1;
+            }
+        }
     }
-  }
   return 0;
 }
 
@@ -1207,7 +1250,7 @@
   struct ConfItem* tmp;
   
   for (; lp; lp = lp->next)
-    {
+    {      
       tmp = lp->value.aconf;
       if ((tmp->status & statmask) && tmp->name && 
           (!irccmp(tmp->name, name) || match(tmp->name, name)))
@@ -1216,6 +1259,7 @@
   return NULL;
 }
 
+
 /* 
  * NOTES
  *
@@ -1289,6 +1333,52 @@
   return NULL;
 }
 
+#ifdef BACKUP
+struct ConfItem* find_conf_main_link()
+{
+  struct ConfItem* conf;
+  struct ConfItem* mainlink = NULL;
+
+  for (conf = ConfigItemList; conf; conf = conf->next)
+    {
+      if(!(conf->status & CONF_CONNECT_SERVER) || conf->port <= 0) continue;
+      if(mainlink == NULL) {
+        mainlink = conf;
+        continue;
+      }
+      if((conf->c_class != NULL) && (mainlink->c_class != NULL))
+        if(ClassType(conf->c_class) > ClassType(mainlink->c_class))
+          mainlink = conf;
+    }
+  return(mainlink);
+}
+struct ConfItem* find_conf_link_but(struct ConfItem* but)
+{
+  struct ConfItem* conf;
+
+  if(but != NULL)
+    for(conf = ConfigItemList; conf; conf = conf->next)
+      {
+        if(!(conf->status & CONF_CONNECT_SERVER) || conf->port <= 0) continue;
+        if(conf != but) return(conf);
+      }
+  return(NULL);
+}
+int count_conf_links()
+{
+  struct ConfItem* conf;
+  int i = 0;  
+
+  for(conf = ConfigItemList; conf; conf = conf->next)
+    {
+       if(!(conf->status & CONF_CONNECT_SERVER) || conf->port <= 0) continue;
+       i++;
+    }
+
+  return(i);
+}
+#endif /* BACKUP */
+
 /*
  * find_conf_by_name - return a conf item that matches host and type
  */
@@ -1649,7 +1739,7 @@
 
   tmptr = localtime(&CurrentTime);
   strftime(timebuffer, MAX_DATE_STRING, "%Y%m%d%H%M", tmptr);
-  if (DPATH[strlen(DPATH)-1] == '/')
+  if (DPATH[irclen(DPATH)-1] == '/')
      (void)sprintf(ircd_dump_file,"%sircd.conf.%s",
                    DPATH,timebuffer);
   else
@@ -1812,7 +1902,7 @@
 
 #define MAXCONFLINKS 150
 
-static void initconf(FBFILE* file, int use_include)
+static int initconf(FBFILE* file, int use_include)
 {
   static char  quotes[] = {
     0,    /*  */
@@ -1857,6 +1947,9 @@
   unsigned long    ip_mask;
   int              sendq = 0;
   aClass*          class0;
+  char*            listenaddr;
+  unsigned long    vaddr;
+  int              ret = 0;
 
   class0 = find_class(0);        /* which one is class 0 ? */
 
@@ -1938,7 +2031,7 @@
       if (!tmp)
         continue;
       dontadd = 0;
-      switch (*tmp)
+      switch(*tmp)
         {
         case 'A': /* Name, e-mail address of administrator */
         case 'a': /* of this server. */
@@ -2050,6 +2143,13 @@
           sendq = 0;
           break;
 
+#ifdef HAVE_SSL
+        case 'S':
+        case 's':
+          aconf->status = CONF_SSL;
+          break;
+#endif
+          
         default:
           log(L_ERROR, "Error in config file: %s", line);
           break;
@@ -2101,9 +2201,22 @@
             }
           else
             {
-              if ((tmp = getfield(NULL)) == NULL)
+              if((tmp = getfield(NULL)) == NULL)
                 break;
-              aconf->port = atoi(tmp);
+#ifdef HAVE_SSL              
+              if(aconf->status & CONF_NOCONNECT_SERVER)
+                {                  
+                  aconf->port = 0;
+                  
+                  if(irccmp(tmp, "SSL") == 0)
+                    aconf->connect_ssl = 1;
+                  else
+                    aconf->connect_ssl = 0;
+                }              
+              else
+#endif
+              
+                aconf->port = atoi(tmp);
             }
 
           Debug((DEBUG_DEBUG,"aconf->port %x",aconf->port));
@@ -2199,10 +2312,20 @@
       if ( aconf->status & CONF_LISTEN_PORT)
         {
           dontadd = 1;
+          
           if((aconf->passwd[0] == '\0') || (aconf->passwd[0] == '*'))
-            add_listener(aconf->port, NULL );
+            listenaddr = NULL;
           else
-            add_listener(aconf->port, (const char *)aconf->passwd);
+            listenaddr = aconf->passwd;
+          
+#ifdef HAVE_SSL          
+          if(aconf->user && irccmp(aconf->user, "SSL") == 0)
+            ret += add_listener(aconf->port, listenaddr, 1); /* SSL listener */
+          else
+            ret += add_listener(aconf->port, listenaddr, 0); /* plain listener */
+#else
+          ret += add_listener(aconf->port, listenaddr);
+#endif
         }
       else if(aconf->status & CONF_CLIENT_MASK)
         {
@@ -2299,7 +2422,8 @@
             {
                 memset(&vserv,0, sizeof(vserv));
                 vserv.sin_family = AF_INET;
-                vserv.sin_addr.s_addr = inet_addr(aconf->passwd);
+                inet_pton(AF_INET, aconf->passwd, &vaddr);
+                memcpy(&vserv.sin_addr, &vaddr, sizeof(struct in_addr));
                 specific_virtual_host = 1;
             }
           }
@@ -2429,6 +2553,21 @@
           aconf->next = u_conf;
           u_conf = aconf;
         }
+#ifdef HAVE_SSL
+      else if(aconf->status & CONF_SSL)
+        {
+          if(aconf->passwd)
+            DupString(ssl_pem_passphrase, aconf->passwd);
+
+          if(aconf->user)
+            ssl_svl = atoi(aconf->user);
+
+          ssl_cvl = aconf->port;
+          
+          if(aconf->host)
+            DupString(ssl_cipher_list, aconf->host);
+        }      
+#endif     
       else if (aconf->status & CONF_QUARANTINED_NICK)
         {
           dontadd = 1;
@@ -2449,7 +2588,7 @@
                    * which just place holds the channel down.
                    */
 
-                  len = strlen(aconf->name);
+                  len = irclen(aconf->name);
                   chptr = (aChannel*) MyMalloc(sizeof(aChannel) + len + 1);
                   memset(chptr, 0, sizeof(aChannel));
                   /*
@@ -2508,6 +2647,8 @@
       log(L_CRIT, "Server has no M: line");
       exit(-1);
     }
+  
+  return ret;
 }
 
 /*
@@ -2642,8 +2783,8 @@
 
   host = cptr->host;
   name = cptr->username;
-  if (strlen(host)  > (size_t) HOSTLEN ||
-      (name ? strlen(name) : 0) > (size_t) HOSTLEN)
+  if (irclen(host)  > (size_t) HOSTLEN ||
+      (name ? irclen(name) : 0) > (size_t) HOSTLEN)
     return (0);
 #endif
   /* If client is e-lined, then its not k-linable */
@@ -3104,6 +3245,10 @@
         int_flags |= FLAGS_DEBUG;
       else if(*flags == 'n')
         int_flags |= FLAGS_NCHANGE;
+#ifdef ENFORCE
+      else if(*flags == 'e')
+        int_flags |= FLAGS_ENFORCE;
+#endif /* -shifty  rel. pi-0.1 */
       flags++;
     }
 
@@ -3463,10 +3608,11 @@
  * side effects - read all conf files needed, ircd.conf kline.conf etc.
  */
 
-void read_conf_files(int cold)
+int read_conf_files(int cold)
 {
   FBFILE* file = 0;     /* initconf */
   const char *filename,*kfilename,*dfilename; /* conf filenames */
+  int ret = 0;
 
   filename = get_conf_name(CONF_TYPE);
 
@@ -3480,14 +3626,14 @@
       else
         {
           sendto_realops("Can't open %s file aborting rehash!", filename );
-          return;
+          return ret;
         }
     }
 
   if(!cold)
     clear_out_old_conf();
 
-  initconf(file, YES);
+  ret = initconf(file, YES);
 
   do_include_conf();
 
@@ -3534,6 +3680,7 @@
         initconf(file, NO);
     }
 
+  return ret;
 }
 
 /*
@@ -3754,7 +3901,7 @@
        
 int safe_write(aClient *sptr, const char *filename, int out, char *buffer)
 {
-  if (write(out, buffer, strlen(buffer)) <= 0)
+  if (write(out, buffer, irclen(buffer)) <= 0)
     {
       sendto_realops("*** Problem writing to %s",filename);
       close(out);
@@ -3817,10 +3964,29 @@
     {
       line = (char *)NULL;
       if ((end = strchr(field,'\n')) == (char *)NULL)
-        end = field + strlen(field);
+        end = field + irclen(field);
     }
   else
     line = end + 1;
   *end = '\0';
   return(field);
 }
+
+#ifdef BACKUP
+      
+struct ConfItem *find_link_by_class(int class_type)
+{
+  struct ConfItem *aconf;
+  struct Class    *cltmp;
+ 
+  for(aconf = ConfigItemList; aconf; aconf = aconf->next) {
+    if (!(aconf->status & CONF_CONNECT_SERVER) || aconf->port <= 0)
+      continue;
+    cltmp = ClassPtr(aconf);
+    if(cltmp->type == class_type) return(aconf);
+  }
+  return((struct ConfItem *)NULL);
+}
+
+#endif /* BACKUP */
+
diff -uNrd ircd-hybrid-6.0/src/s_debug.c ircd-pi1.0a/src/s_debug.c
--- ircd-hybrid-6.0/src/s_debug.c	Fri Nov 24 13:51:18 2000
+++ ircd-pi1.0a/src/s_debug.c	Fri May 10 23:49:05 2002
@@ -17,7 +17,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: s_debug.c,v 1.48 2000/11/24 18:51:18 lusky Exp $
+ *   $Id: s_debug.c,v 1.6 2002/05/11 03:49:05 smoli Exp $
  */
 #include "s_debug.h"
 #include "channel.h"
@@ -35,6 +35,7 @@
 #include "scache.h"
 #include "send.h"
 #include "struct.h"
+#include "irc_string.h"
 
 #include <stdio.h>
 #include <string.h>
@@ -128,6 +129,15 @@
 /* th+hybrid servers ALWAYS do TS_WARNINGS */
   'o',
   'w',
+#ifdef ENFORCE
+  'e',
+#endif
+#ifdef HAVE_SSL
+  '-',
+  'S',
+  'S',
+  'L',
+#endif
   '\0'
 };
 
@@ -299,7 +309,7 @@
           if (acptr->user->away)
             {
               aw++;
-              awm += (strlen(acptr->user->away)+1);
+              awm += (irclen(acptr->user->away)+1);
             }
         }
     }
@@ -309,7 +319,7 @@
   for (chptr = channel; chptr; chptr = chptr->nextch)
     {
       ch++;
-      chm += (strlen(chptr->chname) + sizeof(aChannel));
+      chm += (irclen(chptr->chname) + sizeof(aChannel));
       for (link = chptr->members; link; link = link->next)
         chu++;
       for (link = chptr->invites; link; link = link->next)
@@ -317,12 +327,12 @@
       for (link = chptr->banlist; link; link = link->next)
         {
           chb++;
-          chbm += (strlen(link->value.cp)+1+sizeof(Link));
+          chbm += (irclen(link->value.cp)+1+sizeof(Link));
         #ifdef BAN_INFO
         	if (link->value.banptr->banstr)
-        		chbm += strlen(link->value.banptr->banstr);
+        		chbm += irclen(link->value.banptr->banstr);
         	if (link->value.banptr->who)
-        		chbm += strlen(link->value.banptr->who);
+        		chbm += irclen(link->value.banptr->who);
         #endif /* BAN_INFO */
         }
     }
@@ -330,9 +340,9 @@
   for (aconf = ConfigItemList; aconf; aconf = aconf->next)
     {
       co++;
-      com += aconf->host ? strlen(aconf->host)+1 : 0;
-      com += aconf->passwd ? strlen(aconf->passwd)+1 : 0;
-      com += aconf->name ? strlen(aconf->name)+1 : 0;
+      com += aconf->host ? irclen(aconf->host)+1 : 0;
+      com += aconf->passwd ? irclen(aconf->passwd)+1 : 0;
+      com += aconf->name ? irclen(aconf->name)+1 : 0;
       com += sizeof(aConfItem);
     }
 
diff -uNrd ircd-hybrid-6.0/src/s_log.c ircd-pi1.0a/src/s_log.c
--- ircd-hybrid-6.0/src/s_log.c	Wed Aug  9 18:50:25 2000
+++ ircd-pi1.0a/src/s_log.c	Sat May 18 00:05:58 2002
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: s_log.c,v 1.10 2000/08/09 22:50:25 lusky Exp $
+ *   $Id: s_log.c,v 1.3 2002/05/18 04:05:58 smoli Exp $
  */
 #include "s_log.h"
 #include "irc_string.h"
@@ -103,11 +103,11 @@
 {
   char buf[LOG_BUFSIZE];
   sprintf(buf, "[%s] %s\n", smalldate(CurrentTime), message);
-  write(logFile, buf, strlen(buf));
+  write(logFile, buf, irclen(buf));
 }
 #endif
    
-void log(int priority, const char* fmt, ...)
+void *log(int priority, const char* fmt, ...)
 {
   char    buf[LOG_BUFSIZE];
   va_list args;
@@ -115,7 +115,7 @@
   assert(0 != fmt);
 
   if (priority > logLevel)
-    return;
+    return NULL;
 
   va_start(args, fmt);
   vsprintf(buf, fmt, args);
@@ -128,6 +128,8 @@
 #if defined(USE_LOGFILE) 
   write_log(buf);
 #endif
+  
+  return NULL;
 }
   
 void init_log(const char* filename)
diff -uNrd ircd-hybrid-6.0/src/s_misc.c ircd-pi1.0a/src/s_misc.c
--- ircd-hybrid-6.0/src/s_misc.c	Tue Nov 21 01:49:32 2000
+++ ircd-pi1.0a/src/s_misc.c	Sun May  5 00:42:24 2002
@@ -20,7 +20,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *  $Id: s_misc.c,v 1.69 2000/11/21 06:49:32 lusky Exp $
+ *  $Id: s_misc.c,v 1.4 2002/05/05 04:42:24 smoli Exp $
  */
 #include "s_misc.h"
 #include "client.h"
@@ -184,9 +184,11 @@
         }
       j++;
     }
-
+  
+  j--;
+  
   sendto_one(cptr, ":%s %d %s :%u total server%s",
-             me.name, RPL_STATSDEBUG, name, --j, (j==1)?"":"s");
+             me.name, RPL_STATSDEBUG, name, j, (j==1)?"":"s");
 
   sendto_one(cptr, ":%s %d %s :Sent total : %7.2f %s",
              me.name, RPL_STATSDEBUG, name, _GMKv(sendK), _GMKs(sendK));
diff -uNrd ircd-hybrid-6.0/src/s_serv.c ircd-pi1.0a/src/s_serv.c
--- ircd-hybrid-6.0/src/s_serv.c	Tue Nov 21 01:49:32 2000
+++ ircd-pi1.0a/src/s_serv.c	Thu May 23 00:22:22 2002
@@ -19,12 +19,13 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: s_serv.c,v 1.214 2000/11/21 06:49:32 lusky Exp $
+ *   $Id: s_serv.c,v 1.9 2002/05/23 04:22:22 smoli Exp $
  */
 #include "s_serv.h"
 #include "channel.h"
 #include "class.h"
 #include "client.h"
+#include "config.h"
 #include "common.h"
 #include "fdlist.h"
 #include "hash.h"
@@ -51,7 +52,7 @@
 #include <time.h>
 #include <netdb.h>
 
-#define MIN_CONN_FREQ 300
+#define MIN_CONN_FREQ 60
 
 #ifndef INADDR_NONE
 #define INADDR_NONE ((unsigned int) 0xffffffff)
@@ -59,6 +60,9 @@
 
 int MaxConnectionCount = 1;
 int MaxClientCount     = 1;
+#ifdef BACKUP
+struct Client* backup_drop = NULL;
+#endif /* BACKUP */
 
 /*
  * list of recognized server capabilities.  "TS" is not on the list
@@ -74,6 +78,10 @@
   { "EX",       CAP_EX },
   { "CHW",      CAP_CHW },
   { "DE",       CAP_DE },
+  { "RW",       CAP_RW },
+#ifdef HAVE_SSL  
+  { "SSL",      CAP_SSL },
+#endif
   { 0,   0 }
 };
 
@@ -232,14 +240,33 @@
 
   Debug((DEBUG_NOTICE,"Connection check at: %s", myctime(currenttime)));
 
+#ifdef BACKUP
+  if((main_link = find_conf_main_link()) == NULL) 
+     {
+       sendto_realops("WARNING: No main link!!! I'm not connecting to anywhere...");
+       return((time_t) 0);
+     }   
+  if(backup_drop != NULL) 
+     {
+       confrq = 10;
+       sendto_realops("Dropping backup link. Retrying main link in %d seconds.",
+		      confrq);
+       exit_client(backup_drop, backup_drop, backup_drop, "Dropping backup link");
+       backup_drop = NULL;
+       
+       return (main_link->hold = currenttime + (time_t)confrq);
+     }
+#endif /* BACKUP */
+
   for (aconf = ConfigItemList; aconf; aconf = aconf->next )
     {
       /*
-       * Also when already connecting! (update holdtimes) --SRB 
+         * Also when already connecting! (update holdtimes) --SRB 
        */
       if (!(aconf->status & CONF_CONNECT_SERVER) || aconf->port <= 0)
         continue;
       cltmp = ClassPtr(aconf);
+
       /*
        * Skip this entry if the use of it is still on hold until
        * future. Otherwise handle this entry (and set it on hold
@@ -254,7 +281,7 @@
           continue;
         }
 
-      if ((confrq = get_con_freq(cltmp)) < MIN_CONN_FREQ )
+      if ((confrq = get_con_freq(cltmp)) < MIN_CONN_FREQ)
         confrq = MIN_CONN_FREQ;
 
       aconf->hold = currenttime + confrq;
@@ -263,9 +290,14 @@
        * and see if this server is already connected?
        */
       cptr = find_server(aconf->name);
-      
+
+#ifndef BACKUP
       if (!cptr && (Links(cltmp) < MaxLinks(cltmp)) &&
           (!connecting || (ClassType(cltmp) > con_class)))
+#else
+      if (!cptr && (Links(cltmp) < MaxLinks(cltmp)) && !connecting &&
+          ((backup_mode && (aconf != main_link)) || (!backup_mode && (aconf == main_link))))
+#endif /* BACKUP */
         {
           con_class = ClassType(cltmp);
           con_conf = aconf;
@@ -281,9 +313,22 @@
       /*
        * auto connects disabled, send message to ops and bail
        */
-      if (connecting)
-        sendto_ops("Connection to %s[%s] not activated.",
-                 con_conf->name, con_conf->host);
+      if(connecting)
+        {
+#ifndef BACKUP
+          sendto_ops("Connection to %s[%s] not activated.",
+                     con_conf->name, con_conf->host);
+#else
+          if(backup_mode) {
+            sendto_ops("Connection to backup link %s[%s] not activated.",
+                       con_conf->name, con_conf->host);
+          } else {
+            sendto_ops("Connection to main link %s[%s] not activated.",
+                       con_conf->name, con_conf->host);
+          }
+#endif /* BACKUP */
+        }
+      
       sendto_ops("WARNING AUTOCONN is 0, autoconns are disabled");
       Debug((DEBUG_NOTICE,"Next connection check : %s", myctime(next)));
       return next;
@@ -306,18 +351,51 @@
         }
       if (!(con_conf->flags & CONF_FLAGS_ALLOW_AUTO_CONN))
         {
+#ifndef BACKUP
           sendto_realops("Connection to %s[%s] not activated, autoconn is off.",
                      con_conf->name, con_conf->host);
-          sendto_realops("WARNING AUTOCONN on %s[%s] is disabled",
+#else
+          if(backup_mode) {
+            sendto_ops("Connection to backup link %s[%s] not activated, autoconn is off.",
+                     con_conf->name, con_conf->host);
+          } else {
+            sendto_ops("Connection to main link %s[%s] not activated, autoconn is off.",
+                     con_conf->name, con_conf->host);
+          }
+#endif /* BACKUP */
+            sendto_realops("WARNING AUTOCONN on %s[%s] is disabled",
                      con_conf->name, con_conf->host);
         }
       else
         {
-          if (connect_server(con_conf, 0, 0))
+          if(connect_server(con_conf, 0, 0))
+#ifndef BACKUP
             sendto_realops("Connection to %s[%s] activated.",
                        con_conf->name, con_conf->host);
+          else
+            sendto_realops("Couldn't activate connection to %s[%s].", 
+                       con_conf->name, con_conf->host);
+#else
+          {
+            if(backup_mode)
+              sendto_realops("Connection to backup link %s[%s] activated.",
+                         con_conf->name, con_conf->host);
+            else
+              sendto_realops("Connection to main link %s[%s] activated.",
+                         con_conf->name, con_conf->host);
+           } else {
+            if(backup_mode)
+              sendto_realops("Couldn't activate connection to backup link %s[%s].",
+                         con_conf->name, con_conf->host);
+            else
+              sendto_realops("Couldn't activate connection to main link %s[%s].",
+                         con_conf->name, con_conf->host); 
+           }
+
+#endif
         }
     }
+
   Debug((DEBUG_NOTICE,"Next connection check : %s", myctime(next)));
   return next;
 }
@@ -445,7 +523,12 @@
     {
       /* kludge to rhyme with sludge */
 
-      if (use_zip)
+#ifdef HAVE_SSL
+      if(!IsSSL(cptr) && cap->cap == CAP_SSL)
+        continue;        
+#endif
+      
+      if(use_zip)
         {
           strcat(msgbuf, cap->name);
           strcat(msgbuf, " ");
@@ -459,6 +542,7 @@
             }
         }
     }
+   
   sendto_one(cptr, "CAPAB :%s", msgbuf);
 }
 
@@ -469,7 +553,13 @@
 
   if (IsPerson(acptr))
     {
-      send_umode(NULL, acptr, 0, SEND_UMODES, ubuf);
+#ifdef HAVE_SSL
+      if(!IsSSL(cptr))
+        send_umode(NULL, acptr, 0, SEND_UMODES & ~FLAGS_SSLU, ubuf);
+      else
+#endif        
+        send_umode(NULL, acptr, 0, SEND_UMODES, ubuf);
+      
       if (!*ubuf)
         { /* trivial optimization - Dianora */
           
@@ -500,10 +590,10 @@
   struct Capability* cap;
 
   strcpy(msgbuf,"TS ");
-  if (!acptr->caps)        /* short circuit if no caps */
+  if(!acptr->caps)        /* short circuit if no caps */
     return msgbuf;
 
-  for (cap = captab; cap->cap; ++cap)
+  for(cap = captab; cap->cap; ++cap)
     {
       if(cap->cap & acptr->caps)
         {
@@ -511,6 +601,8 @@
           strcat(msgbuf, " ");
         }
     }
+   
+  msgbuf[irclen(msgbuf) - 1] = '\0';   
   return msgbuf;
 }
 
@@ -532,7 +624,7 @@
   strcpy(inpath_ip, get_client_name(cptr, SHOW_IP));
   inpath = get_client_name(cptr, MASK_IP); /* "refresh" inpath with host */
 
-  split = irccmp(cptr->name, cptr->host);
+  split = strcmp(cptr->name, cptr->host);
   host = cptr->name;
 
   if (!(n_conf = find_conf_name(cptr->confs, host, CONF_NOCONNECT_SERVER)))
@@ -567,7 +659,7 @@
 #else
   encr = cptr->passwd;
 #endif  /* CRYPT_LINK_PASSWORD */
-  if (*n_conf->passwd && 0 != strcmp(n_conf->passwd, encr))
+  if (*n_conf->passwd && strcmp(n_conf->passwd, encr))
     {
       ServerStats->is_ref++;
       sendto_one(cptr, "ERROR :No Access (passwd mismatch) %s",
@@ -603,8 +695,14 @@
       */
 
       send_capabilities(cptr,(c_conf->flags & CONF_FLAGS_ZIP_LINK));
+#ifdef HAVE_SSL
+      sendto_one(cptr, "SERVER %s 1%s :%s",
+                 my_name_for_link(me.name, n_conf),
+                 IsSSL(cptr) ? "S" : "",
+#else
       sendto_one(cptr, "SERVER %s 1 :%s",
-                 my_name_for_link(me.name, n_conf), 
+                 my_name_for_link(me.name, n_conf),                 
+#endif                 
                  (me.info[0]) ? (me.info) : "IRCers United");
     }
   else
@@ -692,6 +790,11 @@
   cptr->serv->nline = n_conf;
   cptr->flags2 |= FLAGS2_CBURST;
 
+#ifdef HAVE_SSL
+  if(IsSSL(cptr))
+     SetSSLServ(cptr);
+#endif
+      
   /*
   ** Old sendto_serv_but_one() call removed because we now
   ** need to send different names to different servers
@@ -706,8 +809,13 @@
           match(my_name_for_link(me.name, n_conf), cptr->name))
         continue;
 
+#ifdef HAVE_SSL
+      sendto_one(acptr,":%s SERVER %s 2%s :%s",
+                 me.name, cptr->name, (IsSSL(cptr) && IsSSLServ(acptr)) ? "S" : "", cptr->info);
+#else
       sendto_one(acptr,":%s SERVER %s 2 :%s",
                  me.name, cptr->name, cptr->info);
+#endif
     }
 
   /*
@@ -744,23 +852,28 @@
 
           /* DON'T give away the IP of the server here
            * if its a hub especially.
-           */
-
-          if (split)
-            sendto_one(cptr, ":%s SERVER %s %d :%s",
+           */                          
+          if(split)
+#ifdef HAVE_SSL
+          /* super paranoya, don't send +S server flag out over unencrypted connections */
+            sendto_one(cptr, ":%s SERVER %s %d%s :%s",
                        acptr->serv->up, acptr->name,
-                       acptr->hopcount+1,
+                       acptr->hopcount+1, (IsSSL(cptr) && IsSSLServ(acptr)) ? "S" : "",
                        acptr->info);
-            /*
-            sendto_one(cptr, ":%s SERVER %s %d :[%s] %s",
+          else
+            sendto_one(cptr, ":%s SERVER %s %d%s :%s",
                        acptr->serv->up, acptr->name,
-                       acptr->hopcount+1,
-                       acptr->host, acptr->info);
-                       */
+                       acptr->hopcount+1, (IsSSL(cptr) && acptr->serv->is_ssl) ? "S" : "",
+                       acptr->info);
+#else
+            sendto_one(cptr, ":%s SERVER %s %d :%s",
+                       acptr->serv->up, acptr->name,
+                       acptr->hopcount+1, acptr->info);
           else
             sendto_one(cptr, ":%s SERVER %s %d :%s",
                        acptr->serv->up, acptr->name,
                        acptr->hopcount+1, acptr->info);
+#endif          
         }
     }
   
@@ -914,3 +1027,95 @@
              cptr->name, j, (j==1) ? "" : "s");
 }
 
+#ifdef BACKUP
+
+void backup_lost_link(struct Client* cptr)
+{
+  time_t now = time(NULL);  
+  int reconn;
+  int confrq;
+  struct ConfItem* nextserv;
+
+  if(((main_link = find_conf_main_link()) == NULL) ||
+      (main_link->c_class == NULL) ||
+      (cptr == NULL) || (cptr->name == NULL)) return;
+
+  if((confrq = main_link->c_class->conFreq) < MIN_CONN_FREQ)
+    confrq = MIN_CONN_FREQ;
+
+  reconn = (rand() % (confrq - 10)) + 10;
+  nextserv = NULL;
+
+  if(strcmp(cptr->name, main_link->name))
+    {
+      if(backup_mode)
+        {
+          if(backup_retry >= (count_conf_links() << 1))
+            {
+              sendto_realops("Tried every backup server twice, leaving backup mode...");
+              backup_mode = 0;
+              backup_retry = 0;
+              nextserv = main_link;                                                                                                                                
+              sendto_realops("Next connection attempt in %d seconds to %s[%s].",
+               	             reconn, nextserv->name, nextserv->host);
+            }
+          else
+            backup_retry++;
+        }
+    }
+  else
+    {
+      if(main_retry)
+        {
+          backup_mode++;
+          main_retry = 0;
+          nextserv = main_link;
+          sendto_realops("Main link unreachable, entering backup mode...");
+          sendto_realops("Next connection attempt in %d seconds to %s[%s]",
+ 		         reconn, nextserv->name, nextserv->host);
+        }
+      else
+        {
+          main_retry++;
+          backup_mode = 0;
+          nextserv = main_link;
+          sendto_realops("Lost main link, trying to reconnect in %d seconds.", reconn);
+        }
+    }
+  
+  if(nextserv != NULL)
+    {
+      nextserv->hold = now + (time_t)reconn;
+      if(nextserv->hold < nextconnect)
+        nextconnect = nextserv->hold;
+    }
+}
+
+int backup_regain_link(struct Client* cptr)
+{
+  time_t now = time(NULL);
+  int reconn;
+  int confrq;
+ 
+  if(!backup_mode)
+    return 0;
+   
+  sendto_realops("Main link went back, leaving backup mode...");
+  backup_mode = 0;
+  backup_retry = 0;
+   
+  if((confrq = main_link->c_class->conFreq) < MIN_CONN_FREQ)
+    confrq = MIN_CONN_FREQ;
+   
+  reconn = (rand() % (confrq - 10)) + 10;
+   
+  if((main_link->hold = now + (time_t) reconn) < nextconnect)
+    nextconnect = main_link->hold;
+    
+  sendto_realops("Dropping backup link in %d seconds.",
+                 reconn);
+  
+  backup_drop = cptr;
+  return 0;
+}
+#endif /* BACKUP */
